
#include "utility.h"
#include <string>
#include <cmath>
#include<vector>
#include<numeric>
#include <iostream>

#include "Dal.h"

#include "SasDalUtils.h"

//#include "dal_utilities.h"
#include "DataSubspace.h"








/**************************************************************
*
*
***************************************************************/

bool isNull(int8 value)
{  

    if( value == 127)
      return true;
    else
    return false;    

}
bool isNull(int16 value)
{  

    if( value == 32767)
      return true;
    else
    return false;    

}

bool isNull(int32 value)
{  

       
    stringstream ss;
    ss << value;
    string text = ss.str();
 
        
    if ( (int)text.find("nan") >= 0) return true;
    if ( (int)text.find("NAN") >= 0) return true;
    if ( (int)text.find("null") >= 0) return true;
    if ( (int)text.find("NULL") >= 0) return true;

    return false;    


}




bool isNull( float value)
{  



    stringstream ss;
    ss << value;
    string text = ss.str();
 


        
    if ( (int)text.find("nan") >= 0) return true;
    if ( (int)text.find("NAN") >= 0) return true;
    if ( (int)text.find("null") >= 0) return true;
    if ( (int)text.find("NULL") >= 0) return true;

    return false;    

};

bool isNull( double value)
{  

   
    stringstream ss;
    ss << value;
    string text = ss.str();
    
    if ( (int)text.find("nan") >= 0) return true;
    if ( (int)text.find("NAN") >= 0) return true;
    if ( (int)text.find("null") >= 0) return true;
    if ( (int)text.find("NULL") >= 0) return true;

    return false;    

};

bool isNull( char * value)
{  

    stringstream ss;
    ss << value;
    string text = ss.str();
         
    if ( (int)text.find("nan") >= 0) return true;
    if ( (int)text.find("NAN") >= 0) return true;
    if ( (int)text.find("null") >= 0) return true;
    if ( (int)text.find("NULL") >= 0) return true;

    return false;    

};

















/**************************************************************
*
**************************************************************/
bool getValue(string text, int &value, int xMin = 0, int xMax = 0)
{

    errno = 0;
    char *endPtr = 0;
    int value1 = strtol(text.c_str(), &endPtr, 10);


    value = value1;

    
    //    if (endPtr)
    //    {
     
    //        cout << "line 189 get value - value=" << value << endl;
    //        cout << "endptr=" << endPtr << " length=" << strlen(endPtr) << endl;

    //       for(unsigned i = 0; i < strlen(endPtr) - 2; i++)
    //	{
    //	  cout << i << " endptr=" << endPtr[i] << endl;
    //        if( endPtr[i] != ' ' or endPtr[i] != '\0' ) {
    //            char text1[100];
    //             sprintf(text1, "Invalid number - %s - Please try again!", text.c_str());
      

    //              QMessageBox::critical( 0, "OMCATALOGUE", text1);

    //           return false;
    //        }
    //    }

    //  } 


    if(errno != 0) {
    
        char text1[100];
        sprintf(text1, "Invalid number - %s (%s) - Please try again!", text.c_str(), strerror(errno));
      

        QMessageBox::critical( 0, "OMCATALOGUE", text1);
 

        return false;

    }


    if(xMin != xMax)
    {
        if(value < xMin || value > xMax) {

            char text1[100];
            sprintf(text1, "Number %d outside allowed range- %d - %d - Please try again!", value1, xMin, xMax );
      

            QMessageBox::critical( 0, "OMCATALOGUE", text1);
 

            return false;
        }





    }




    
    value = value1;
    return true;

   




};








/*******************************************************************
*
*******************************************************************/
double distance(double r1, double d1, double r2, double d2)
{



    return acos( sin(d1) * sin(d2) + cos(d1) * cos(d2) 
	            * cos(r1 - r2) ) * radiansToArcSecs; 


};
/*************************************************************************
*
***************************************************************************/
double Error(double dx, double dy)
{
  if (dx > dy)
    return dx * sqrt(1.0 + (dy / dx) * (dy / dx));
  else
    return dy * sqrt(1.0 + (dx / dy) * (dx / dy));
} 

/***************************************************************
*
*
****************************************************************/
float Median(vector<float> &data)
{
    float median;
    int nData = data.size();

    if (nData == 0) return 0.0;
    if (nData == 1) return data[0]; 

    int n2 = nData / 2;

    if ( n2 * 2 == nData ) // Even number of points
        median = (data[n2 - 1] + data[n2]) / 2.0;
    else
      median = data[n2];

    return median;
}    
/***************************************************************
*
*
****************************************************************/
float Mean(float *data, long nData)
{

    double mean = 0.0;
    if (nData == 0) return 0.0;

    for( long i = 0; i < nData; i++)
        mean += (double)data[i];

    return (float)(mean / (double)nData);

}

/***************************************************************
*
*
****************************************************************/
float Mean(vector<float> &data)
{
    if (data.size() == 0) return 0.0;


    return (float)(accumulate( data.begin(), data.end(), 0.0 ) / double(data.size() ));


}

/***************************************************************
*
*
****************************************************************/
float Median(float *data, long nData)
	{
    float median;


    if (nData == 0) return 0.0;
    if (nData == 1) return data[0]; 



  
    int n2 = nData / 2;

    if ( n2 * 2 == nData ) // Even number of points
        median = (data[n2 - 1] + data[n2]) / 2.0;
    else
      median = data[n2];

    return median;
}    

/***************************************************************
*
*
****************************************************************/
float Percentile(vector<float> &data, float perCent)
{

    long size = data.size();
    
    long index = (long)(perCent * (float)size + 0.00001) - 1;
    index = max((long)0, index);
    index = min(index, size - 1); 
     
    cout << "n=" << size << " percent=" << perCent << " index=" << index << " percentile=" << data[index] << endl;
    cout << "data[0]=" << data[0] << " data[" << (size - 1) << "]" << data[size - 1] << endl;
    return data[index];

}
/***************************************************************
*
*
****************************************************************/
float Percentile(float *data, long size, float perCent)
{

 
    
    long index = (long)(perCent * (float)size + 0.00001) - 1;
    index = max((long)0, index);
    index = min(index, size - 1); 

    return data[index];

}


/*******************************************************
*
*
*******************************************************/


vector<vector<int8> >  loadInt8Image(const DataSet *set, const char * name, int &nx, int &ny)
{



    /*****************************************************************
    *
    * Get the size of the image
    *
    *****************************************************************/
    const Array* array = set->array(name);



    const ArrayData * arraydata = array->data();
    if( arraydata->dataType() == Dal::Int8)
    {

        const int8 * theData = arraydata->int8Data();
 

        /*****************************************************************
        * Get the size of the image
        *****************************************************************/
 
        longVec size = array->size();
   



        nx = (int)size[1];
        ny = (int)size[0];


        vector< vector<int8> > image(nx); 


        for (int i = 0; i < nx; i++)
        {
            image[i].resize(ny); 
            for (int j = 0; j < ny; j++)
            {
	        image[i][j] = theData[i + (j * nx)];  
	 

            }

  
        }


        delete arraydata;
   
        return image;

    }


 
    const int16 * theData = arraydata->int16Data();
 

    /*****************************************************************
    * Get the size of the image
    *****************************************************************/
 
    longVec size = array->size();
  
    nx = (int)size[1];
    ny = (int)size[0];



    vector< vector<int8> > image(nx, vector<int8>(ny) ); 

    for (int i = 0; i < nx; i++)
    {
      
        for (int j = 0; j < ny; j++)
        {

            int16 data = theData[i + (j * nx)]; 
            if (data >= 0)
	    {
	      if ( bitSet(data, 0) )
	      {
	          image[i][j] = 1;
              }  
	      else
	      {
                  image[i][j] = 0;  
	      }
            }
            else
	    {
	        image[i][j] = 127; 
            }  

        }

  
    }


    delete arraydata;
   

    return image;
}

/*******************************************************
*
*
*
*******************************************************/


vector<vector<int16> >  loadInt16Image(const DataSet *set, const char * name, int &nx, int &ny)
{


    /*****************************************************************
    * Get the size of the image
    *****************************************************************/
    const Array* array = set->array(name);
 

    const ArrayData * arraydata = array->data();
    const int16 * theData = arraydata->int16Data();
 

    /*****************************************************************
    * Get the size of the image
    *****************************************************************/
 
    longVec size = array->size();
   



    nx = (int)size[1];
    ny = (int)size[0];


    vector< vector<int16> > image(nx); 


    for (int i = 0; i < nx; i++)
    {
        image[i].resize(ny); 
        for (int j = 0; j < ny; j++)
        {
	  image[i][j] = theData[i + (j * nx)];  
	 

        }

  
    }


    delete arraydata;
   

    return image;
}
/********************************************************************************
*
*
********************************************************************************/

bool modifyInt16Image(DataSet *set, const char * name, const vector<vector<int16> > &image)
{

    /*****************************************************************
    * Get the size of the image
    *****************************************************************/
    Array *array = set->array(name);
 

    ArrayData * arraydata = array->data();
    int16 * theData = arraydata->int16Data();
 

    /*****************************************************************
    * Get the size of the image
    *****************************************************************/

    int nx = (int)image.size();
    int ny = (int)image[0].size();


 


    for (int i = 0; i < nx; i++)
    {
    
        for (int j = 0; j < ny; j++)
        {
	   theData[i + (j * nx)] = image[i][j];  
	 

        }

  
    }


    delete arraydata;
   

    return true;
}




/*******************************************************
*
*
*******************************************************/
void addInt16Image(DataSet *set, const char *name, const vector< vector<int16> >& image)

{


    unsigned nx = image.size();
    unsigned ny = image[0].size();
    longVec size(2);
    size[0] = ny;
    size[1] = nx;
   
   
    //   cout << "Adding integer 16 quality image\n";
  
  
    Array * array  = set->addArray(name,
				   Dal::Int16,
				   size);
    ArrayData * arraydata = array->data();
    int16 * data = arraydata->int16Data();
 

    array->nullValue((long)32767);

    //    cout << "nullvalue=" << array->intNullValue() << endl;

    unsigned dx = size[1];
    unsigned dy = size[0];

    for (unsigned x = 0; x < dx; ++x)
    {
      for (unsigned y = 0; y < dy; ++y)
      {
             
	  int index = x + y * dx; 
	  if( image[x][y] >= 0)
	  {    
	        data[index] = image[x][y];
	  }
	  else
	  {
	      arraydata->setToNull(index);
          }
      }

    }

    delete arraydata;


}


/*******************************************************
*
*
*******************************************************/


vector<vector<int8> >  loadInt8Image(const string inSet, const char * name, int &nx, int &ny)
{


    DataSet *set = dataSetServer->open(inSet, Dal::Read);
 
    vector<vector<int8> >  image = loadInt8Image( set, name, nx, ny);




    dataSetServer->close( set ); // Finished with the file

    return image;
}




/*******************************************************
*
*
*******************************************************/


vector<vector<int16> >  loadInt16Image(const string inSet, const char * name, int &nx, int &ny)
{


    DataSet *set = dataSetServer->open(inSet, Dal::Read);
 


    /*****************************************************************
    * Get the size of the image
    *****************************************************************/
    const Array* array = set->array(name);
 

    const ArrayData * arraydata = array->data();
    const int16 * theData = arraydata->int16Data();
 

    /*****************************************************************
    * Get the size of the image
    *****************************************************************/
 
    longVec size = array->size();
   



    nx = (int)size[1];
    ny = (int)size[0];


    vector< vector<int16> > image(nx); 


    for (int i = 0; i < nx; i++)
    {
        image[i].resize(ny); 
        for (int j = 0; j < ny; j++)
        {
            

	  image[i][j] = theData[i + (j * nx)];  
	 
	
        }

  
    }


    delete arraydata;
   
    dataSetServer->close( set ); // Finished with the file

    return image;
}



/*******************************************************
*
*
*******************************************************/


vector<vector<float> >  loadFloatImage(const string inSet, const char * name, int &nx, int &ny)
{


    DataSet *set = dataSetServer->open(inSet, Dal::Read);
 


    /*****************************************************************
    * Get the size of the image
    *****************************************************************/
    const Array* array = set->array(name);
 

    const ArrayData * arraydata = array->data();
    float * theData = arraydata->real32Data();
 

    /*****************************************************************
    * Get the size of the image
    *****************************************************************/
 
    longVec size = array->size();
   



    nx = (int)size[1];
    ny = (int)size[0];


    vector< vector<float> > image(nx); 


    for (int i = 0; i < nx; i++)
    {
        image[i].resize(ny); 
        for (int j = 0; j < ny; j++)
        {
            

	  image[i][j] = theData[i + (j * nx)];  
	 
	
        }

  
    }


    delete arraydata;
   
    dataSetServer->close( set ); // Finished with the file

    return image;
}



